%{
/*
 * Copyright 1991, 1992, John F. Haugh II
 * All rights reserved.
 *
 * Permission is granted to copy and create derivative works for any
 * non-commercial purpose, provided this copyright notice is preserved
 * in all copies of source code, or included in human readable form
 * and conspicuously displayed on all copies of object code or
 * distribution media.
 */

#include <sys/types.h>
#include "is_lex.h"
#include "is_types.h"

#ifndef lint
static	char	sccsid[] = "@(#)dbslex.l	1.5	10:33:46	2/26/92";
#endif

#if MAXFILENAME > MAXFIELDNAME
char	last_name[MAXFILNAME+1];
#else
char	last_name[MAXFIELDNAME+1];
#endif
%}
%%
database	{ return L_DATABASE; }
file		{ return L_FILET; }
field		{ return L_FIELD; }
type		{ return L_TYPE; }
char		{ return L_CHAR; }
length		{ return L_LENGTH; }
short		{ return L_SHORT; }
int		{ return L_INT; }
long		{ return L_LONG; }
serial		{ return L_SERIAL; }
date		{ return L_DATE; }
float		{ return L_FLOAT; }
double		{ return L_DOUBLE; }
money		{ return L_MONEY; }
index		{ return L_INDEX; }
end		{ return L_END; }
unique		{ return L_UNIQUE; }
screen		{ return L_SCREEN; }
joining		{ return L_JOINING; }
ascending	{ return L_ASCENDING; }
descending	{ return L_DESCENDING; }
readonly	{ return L_READONLY; }
[ \t\n]		{ }
[A-Za-z][A-Za-z0-9_]*	{
#if MAXFILENAME > MAXFIELDNAME
			strncpy (last_name, yytext, MAXFILENAME);
			last_name[MAXFILENAME] = '\0';
#else
			strncpy (last_name, yytext, MAXFIELDNAME);
			last_name[MAXFIELDNAME] = '\0';
#endif
			return L_NAME;
		}
[0-9]+		{ return L_NUMBER; }
[,]		{ return ','; }
[(]		{ return L_OPAR; }
[)]		{ return L_CPAR; }
[{]		{ int c;
			while ((c = input ()) != '}' && c != EOF)
				;
		}
%%
